<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2020 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo
 * Release Date: 2019-01-08
 */
define('IN_DOUCO', true);

$sub = 'submit';
$subbox = array(
        "module" => 'form',
        "sub" => $sub
);

$_CUR = 'form';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// 验证并获取合法REQUEST
$id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 载入并实例化类库
require (ROOT_PATH . 'include/form.class.php');
$form = new Form();

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'form', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 表单
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    /* 获取详细信息 */
    $form_info = $dou->get_row('form', '*', "form_id = '$id'");
 
    if ($form_info) {
        $form_info['elements_list'] = $form->get_form_elements_list($id);
    } else {
        $dou->dou_msg($GLOBALS['_LANG']['page_wrong'], HOME_URL);
    }
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('form'));
    $smarty->assign('ur_here', $dou->ur_here('form'));
    $smarty->assign('head', $_LANG['form']);
    $smarty->assign('form', $form_info);
 
    $smarty->display('form.dwt');
}

/**
 * +----------------------------------------------------------
 * 表单提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'submit') {
    $form_id = $check->is_number($_REQUEST['form_id']) ? $_REQUEST['form_id'] : '';
    
    // 必填项不能为空
    $data_must_fill = $dou->fn_query("SELECT * FROM " . $dou->table('form_elements') . " WHERE form_id = '$form_id' AND must_fill = '1' ORDER BY sort ASC, id ASC");
    foreach ($data_must_fill as $row) {
        if (!$_POST[$row['unique_id']])
            $wrong[$row['unique_id']] = $row['name'] . $_LANG['is_empty'];
    }
 
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }
    
    // 检查IP是否频繁咨询
    if (is_water($ip))
        $dou->dou_msg($_LANG['form_is_water'], $_URL['consultation']);
    
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['edit']);
    }
    
    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);

    // 自定义选项
    $data = $dou->fn_query("SELECT * FROM " . $dou->table('form_elements') . " WHERE form_id = '$form_id' ORDER BY id ASC");
    foreach ($data as $row) {
        $post_array[$row['unique_id']] = $_POST[$row['unique_id']];
    }
    $data_box = serialize($post_array);
 
    // 格式化数据
    $ip = $dou->get_ip();
    $add_time = time();
    $back_url = $dou->get_one("SELECT back_url FROM " . $dou->table('form') . " WHERE form_id = '$form_id'");
    $back_url = $back_url ? $back_url : $dou->param($_URL['form'] . '&id=' . $form_id);
 
    // 插入报名
    $dou->query("INSERT INTO " . $dou->table('form_data') . " (id, form_id, data_box, ip, add_time)" . " VALUES (NULL, '$form_id', '$data_box', '$ip', '$add_time')");
    
    $dou->dou_msg($_LANG['form_submit'] . $_LANG['success'], $back_url);
}

/**
 * +----------------------------------------------------------
 * 防灌水
 * +----------------------------------------------------------
 */
function is_water($ip) {
    $unread = $GLOBALS['dou']->get_one("SELECT COUNT(*) FROM " . $GLOBALS['dou']->table('form_data') . " WHERE ip = '$ip' AND status = 0");
    
    // 如果管理员未回复的咨询数量大于1
    if ($unread > '1')
        return true;
}

?>